/*! 
    \file factory.h
    \brief philosophy stuff
*/

#ifndef _FACTORY_H
#define _FACTORY_H

class BaseObject;

#include "xmlparser/tinyxml.h"

//! The Factory is
/**
	Very philosophic description, huh?
*/
class Factory {

 public:
  Factory ();
  ~Factory ();

	virtual BaseObject* fabricate( TiXmlElement* root);
	void initialize();
 	void registerFactory( Factory* factory);
	void setClassname(char* name) {classname = name;}
	char* getClassname() {return classname;};
	void setNext( Factory* factory) {next = factory;}
	Factory* getNext() {return next;}
	
 private:
	char* classname;
	
  Factory* next;
};

// helper function

const char* grabParameter( TiXmlElement* root, const char* name);

#endif /* _FACTORY_H */

